package jp.halfmoon.inaba.aiwolf.lib;



import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map.Entry;

import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Vote;

/**
 * ʊ֐
 */
public final class Common {

	/**
	 * RXgN^(CX^X֎~)
	 */
	private Common(){}



	/**
	 * c菈Y񐔂̎擾iŏI܂őOj
	 * @param aliveAgentNum G[WFg
	 * @return c菈Y
	 */
	public static int getRestExecuteCount(int aliveAgentNum){

		// (Ґ - 1) / 2 i؎̂ājc菈Y
		return (aliveAgentNum - 1) / 2;

	}


	/**
	 * G[WFgԍ̃Xg擾
	 * @param agents
	 * @return
	 */
	public static List<Integer> getAgentNo(List<Agent> agents){

		List<Integer> ret = new ArrayList<Integer>();

		for( Agent agent : agents ){
			ret.add(agent.getAgentIdx());
		}

		return ret;

	}


	/**
	 * Q̔̎n擾
	 * @param day1 P̓
	 * @param talkid1 P̔ID
	 * @param day2 Q̓
	 * @param talkid2 Q̔ID
	 * @return -1:1@0:@1:2
	 */
	public static int compareTalkID( int day1, int talkid1, int day2, int talkid2 ){

		// P悩
		if( day1 < day2 || ( day1 == day2 && talkid1 < talkid2 ) ){
			return -1;
		}

		// Q悩
		if( day1 > day2 || ( day1 == day2 && talkid1 > talkid2 ) ){
			return 1;
		}

		// 
		return 0;

	}


	/**
	 * ő[𓾂҂No擾i[͕擾j
	 * @param voteList [
	 * @return
	 */
	public static List<Integer> getMaxVoteAgentNo(List<Vote> voteList){

		// G[WFg̓[擾}bv key=AgentNo value=[
		HashMap<Integer, Integer> map = new HashMap<Integer, Integer>();

		// [JEg
		for( Vote vote : voteList ){
			int target = vote.getTarget().getAgentIdx();

			if( map.containsKey(target) ){
				map.put(target, map.get(target) + 1);
			}else{
				map.put(target, 1);
			}
		}

		// ő̓[擾
		int maxVoteCount = 0;
		for( Entry<Integer, Integer> entry : map.entrySet() ){
			if( entry.getValue() > maxVoteCount ){
				maxVoteCount = entry.getValue();
			}
		}

		// ő̓[̃G[WFgXg
		List<Integer> ret = new ArrayList<Integer>();
		for( Entry<Integer, Integer> entry : map.entrySet() ){
			if( entry.getValue() == maxVoteCount ){
				ret.add( entry.getKey() );
			}
		}

		return ret;

	}


}
