package jp.halfmoon.inaba.aiwolf.request;

import java.util.ArrayList;
import java.util.List;

import jp.halfmoon.inaba.aiwolf.guess.InspectedWolfsidePattern;
import jp.halfmoon.inaba.aiwolf.lib.ComingOut;


/**
 * spuPP(l)v
 */
public final class PowerPlay_Possessed extends AbstractActionStrategy {

	@Override
	public ArrayList<Request> getRequests(ActionStrategyArgs args) {

		ArrayList<Request> Requests = new ArrayList<Request>();
		Request workReq;


		// PP˓ςłȂ΋󃊃XgԂ
		if( !args.agi.isEnablePowerPlay_Possessed() ){
			return Requests;
		}



		// [킹G[WFg擾
		Integer mostWolfAgentNo = null;

		// l_̊mT擾i擪Pj
		for( int i = 1; i < args.agi.gameSetting.getPlayerNum(); i++ ){
			if( args.agi.selfRealRoleViewInfo.isFixBlack(i) ){
				mostWolfAgentNo = i;
				break;
			}
		}

		// mTȂ
		if( mostWolfAgentNo == null ){
			// lObn҂ꍇAłbn҂ɓ[킹
			for( ComingOut co :args.agi.wolfsideComingOutList ){
				if( co.isEnable() && !args.agi.selfRealRoleViewInfo.isFixWhite(co.agentNo) ){
					mostWolfAgentNo = co.agentNo;
					break;
				}
			}

		}

		//TODO mTɂ킹iρjbnTɍ킹iρjm聛ɓ[iρjNP[ɂHij̋tɓ[ij

		// mTꍇAmTɓ[킹
		if( mostWolfAgentNo != null ){

			Integer target = args.agi.getSaidVoteAgent(mostWolfAgentNo);

			if( target != null && target != args.agi.latestGameInfo.getAgent().getAgentIdx() ){
				workReq = new Request( target );
				workReq.vote = 1000000.0;

				// sv̓o^
				Requests.add(workReq);

				return Requests;
			}
		}




		// lԊm̃G[WFg擾
		List<Integer> fixHumanAgentNo = new ArrayList<Integer>();

		// l_̊mlԂ擾
		for( int i = 1; i < args.agi.gameSetting.getPlayerNum(); i++ ){
			if( args.agi.selfRealRoleViewInfo.isFixWhite(i) ){
				fixHumanAgentNo.add(i);
			}
		}

		// mlԂꍇAmlԂɓ[
		if( !fixHumanAgentNo.isEmpty() ){
			for( int human : fixHumanAgentNo ){
				workReq = new Request( human );
				workReq.vote = 1000000.0;

				// sv̓o^
				Requests.add(workReq);
			}

			return Requests;
		}






		//TODO l_ŐȂƃXRAidΒ߂Hj

		// P̍l@Ɛwcl@̏d݂߂iՂ͔XxŁAIՂ͂قڐwcl@݂̂ɂj
		double singleScoreWeight = Math.min( 0.01, 0.5 - args.agi.latestGameInfo.getDay() * 0.1 );
		double teamScoreWeight = Math.max( 0.99, 0.5 + args.agi.latestGameInfo.getDay() * 0.1 );

		// eG[WFg P/wcő  T XRAɉėvς
		for( int i = 1; i <= args.agi.gameSetting.getPlayerNum(); i++ ){

			// P̘Tp^[擾
			InspectedWolfsidePattern singleWolfPattern = args.aguess.getSingleWolfPattern(i);
			// TƂčłÓȃp^[擾
			InspectedWolfsidePattern mostWolfPattern = args.aguess.getMostValidWolfPattern(i);

			if( mostWolfPattern != null ){
				// T̉\
				workReq = new Request( i );
				workReq.vote = 1 / Math.pow(singleWolfPattern.score, singleScoreWeight) * Math.pow(mostWolfPattern.score, teamScoreWeight) * 100;

				// sv̓o^
				Requests.add(workReq);
			}

		}

		return Requests;

	}

}
