package jp.halfmoon.inaba.aiwolf.request;

import java.util.ArrayList;
import java.util.List;

import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.net.GameInfo;

import jp.halfmoon.inaba.aiwolf.lib.CauseOfDeath;
import jp.halfmoon.inaba.aiwolf.lib.Judge;


/**
 * spuȄd݁v
 */
public final class RoleWeight_Wolfside extends AbstractActionStrategy {

	@Override
	public ArrayList<Request> getRequests(ActionStrategyArgs args) {

		//TODO ]TȂǁA󋵔f@艺iS̓IɁj
		//TODO ҐΉ

		GameInfo gameInfo = args.agi.latestGameInfo;

		ArrayList<Request> Requests = new ArrayList<Request>();
		Request workReq;



		// E܂Ă邩`FbN
		boolean isAttackedSeer = false;
		boolean isAttackedMedium = false;
		for( int i = 1; i <= args.agi.gameSetting.getPlayerNum(); i++  ){
			if( args.agi.agentState[i].causeofDeath == CauseOfDeath.ATTACKED ){
				if( args.agi.agentState[i].comingOutRole == Role.SEER ){
					isAttackedSeer = true;
				}
				if( args.agi.agentState[i].comingOutRole == Role.MEDIUM ){
					isAttackedMedium = true;
				}
			}
		}


		// ႢEႢ
		List<Judge> seerJudges = args.agi.getSeerJudgeList();
		for( Judge judge : seerJudges ){

			// Ȕł΃XLbv
			if( !judge.isEnable() ){
				continue;
			}

			// 픻҂Ɏł΃XLbv
			if( args.agi.agentState[judge.targetAgentNo].causeofDeath != CauseOfDeath.ALIVE ){
				continue;
			}

			if( judge.result == Species.WEREWOLF){

				// Ⴂ
				workReq = new Request( judge.targetAgentNo );

				// mlOłȂ
				if( !args.agi.selfViewInfo.isFixWolfSide(judge.agentNo) ){
					workReq.inspect = Math.min( 0.2 + gameInfo.getDay() * 0.15 , 0.8 );	// ̌o߂ɏ] 0.35(1d)0.50c0.80(4d) 0.80܂ŏ㏸
					workReq.guard = Math.min( 0.1 + gameInfo.getDay() * 0.02 , 0.8 );	// ̌o߂ɏ] 0.12(1d)0.14c0.20(4d) 0.20܂ŏ㏸
					workReq.vote = Math.max( 3.8 - gameInfo.getDay() * 0.7 , 1.0 );		// ̌o߂ɏ] 3.10(1d)2.40c1.00(4d) 1.00܂Œቺ
				}

				workReq.attack = 0.1;

				// sv̓o^
				Requests.add(workReq);

			}else{

				// Ⴂ
				workReq = new Request( judge.targetAgentNo );

				workReq.inspect = Math.min( 0.6 + gameInfo.getDay() * 0.1 , 1.0 );	// ̌o߂ɏ] 0.70(1d)0.80c1.00(4d) 1.00܂ŏ㏸
				workReq.guard = 1.2;
				workReq.vote = Math.min( 0.4 + gameInfo.getDay() * 0.2 , 1.0 );		// ̌o߂ɏ] 0.60(1d)0.80c1.00(3d) 1.00܂ŏ㏸@[킹\͂ア̂ŁA߂Ɏł

				// ^̔肩
				if( !args.agi.isWolf(judge.agentNo) ){
					workReq.attack = 1.2;
				}

				// sv̓o^
				Requests.add(workReq);

			}
		}

		// eECO҂擾
		List<Integer> seers = args.agi.getEnableCOAgentNo(Role.SEER);
		List<Integer> mediums = args.agi.getEnableCOAgentNo(Role.MEDIUM);
		List<Integer> bodyguards = args.agi.getEnableCOAgentNo(Role.BODYGUARD);
		List<Integer> villagers = args.agi.getEnableCOAgentNo(Role.VILLAGER);

		// CO
		for( int seer : seers ){
			workReq = new Request( seer );

			// ΍R肢͔
			workReq.inspect = 0.05;
			// COɉČq𑝂₷
			if( seers.size() <= 1 ){
				// 1CO
				workReq.guard = 10.0;
			}else if( seers.size() <= 2 ){
				// 2CO
				workReq.guard = 4.0;
			}else if( seers.size() <= 3 ){
				// 3CO
				workReq.guard = 2.0;
			}else{
				// 4COȏ
				workReq.guard = 1.0;
			}
			// ΍R肪܂ĂāAP삪ĂΌq𔖂
			if( isAttackedSeer &&
			    mediums.size() == 1 && !isAttackedMedium ){
				workReq.guard *= 0.7;
			}

			workReq.vote = Math.min(Math.max( -0.2 + gameInfo.getDay() * 0.3 , 0.0) , 1.0 ) + (isAttackedSeer ? 0.2 : 0.0);	// ̌o߂ɏ] 0.10(1d)0.70c1.00(4d) 1.00܂ŏ㏸
			workReq.attack = 2.0;

			// sv̓o^
			Requests.add(workReq);
		}

		// CO
		for( int medium : mediums ){
			workReq = new Request(medium);

			// \肢͔
			workReq.inspect = 0.05;
			// P͉lグA͉l
			if( mediums.size() <= 1 ){
				// 1CO
				workReq.guard = 3.0;
				workReq.vote = Math.min(Math.max( -0.2 + gameInfo.getDay() * 0.3 , 0.0) , 1.0 );	// ̌o߂ɏ] 0.10(1d)0.70c1.00(4d) 1.00܂ŏ㏸
				workReq.attack = 0.4;
			}else{
				// 2COȏ
				workReq.guard = 0.1;
				workReq.vote = Math.max( 1.0 + mediums.size() + (isAttackedMedium ? 0.6 : 0.0) - gameInfo.getDay() * 0.5 , 1.0 );	// ̌o߂ɏ] 2.50(1d)2.00c1.0(4d) 1.00܂Œቺ(2COBCOɍX+1.0)
				workReq.attack = 0.05;
			}

			// sv̓o^
			Requests.add(workReq);
		}


		// CO
		for( int bodyguard : bodyguards ){
			workReq = new Request(bodyguard);

			workReq.inspect = 0.3;	// ݂҂Ȃ琄Ōߑł̂L
			workReq.guard = 0.001;	// 뎋_ł͎ȊO͋Um
			workReq.vote = 1.0;
			workReq.attack = 16.0;

			// sv̓o^
			Requests.add(workReq);
		}


		// CO
		for( int villager : villagers ){
			workReq = new Request(villager);

			// m̂߉l
			workReq.guard = 0.8;
			workReq.vote = 1.0;
			workReq.attack = 0.8;

			// sv̓o^
			Requests.add(workReq);
		}


		return Requests;

	}

}
