package jp.halfmoon.inaba.aiwolf.strategyplayer;

import java.util.ArrayList;
import java.util.List;

import jp.halfmoon.inaba.aiwolf.request.AbstractActionStrategy;
import jp.halfmoon.inaba.aiwolf.request.Request;

/**
 * espNX󂯎sv
 */
public class ReceivedRequest {

	/** sv̓e */
	public Request request;

	/** vsp */
	public AbstractActionStrategy strategy;

	/** v̏d(vW^v̏d)@S̗vɑ΂Ă */
	public double weight = 1.0;


	public ReceivedRequest(Request request, AbstractActionStrategy strategy){
		this.request = request;
		this.strategy = strategy;
	}

	public ReceivedRequest(Request request, AbstractActionStrategy strategy, double weight){
		this.request = request;
		this.strategy = strategy;
		this.weight = weight;
	}

	public static List<ReceivedRequest> newRequests(ArrayList<Request> requests, AbstractActionStrategy strategy){

		ArrayList<ReceivedRequest> rguesses = new ArrayList<ReceivedRequest>();

		for(Request request: requests){
			ReceivedRequest rrequest = new ReceivedRequest(request, strategy);
			rguesses.add(rrequest);
		}

		return rguesses;

	}

	public static List<ReceivedRequest> newRequests(ArrayList<Request> requests, AbstractActionStrategy strategy, double weight){

		ArrayList<ReceivedRequest> rguesses = new ArrayList<ReceivedRequest>();

		for(Request request: requests){
			ReceivedRequest rrequest = new ReceivedRequest(request, strategy, weight);
			rguesses.add(rrequest);
		}

		return rguesses;

	}

}
