package jp.halfmoon.inaba.aiwolf.condition;

import java.util.ArrayList;
import java.util.List;

import jp.halfmoon.inaba.aiwolf.lib.WolfsidePattern;

/**
 * ̏OR肷NX(w1ꍇTrue)
 */
public final class OrCondition extends AbstractCondition {

	/** ̃Xg */
	private List<AbstractCondition> conditions = new ArrayList<AbstractCondition>();


	@Override
	public boolean isMatch( WolfsidePattern pattern ) {

		// Pꍇ́A𖞂ɂ
		if( conditions.isEmpty() ){
			return true;
		}

		// P`FbNAPł΁@OR𖞂
		for( AbstractCondition condition : conditions ){
			if( condition.isMatch(pattern) ){
				return true;
			}
		}

		// 𖞂̂OR𖞂Ȃ
		return false;

	}

	/**
	 * ǉ(chainable)
	 * @param condition ǉ
	 * @return g̃IuWFNg
	 */
	public OrCondition addCondition( AbstractCondition condition ){

		conditions.add(condition);

		return this;

	}


	@Override
	public ArrayList<Integer> getTargetAgentNo() {

		// G[WFgԍ̃Xg
		ArrayList<Integer> ret = new ArrayList<Integer>();

		// q𑖍
		for( AbstractCondition condition : conditions ){
			// qG[WFgԍ̃Xg擾
			ArrayList<Integer> subret = condition.getTargetAgentNo();
			// 擾G[WFgԍAdpăXgɒǉ
			for( Integer agentno : subret ){
				if( !ret.contains(agentno) ){
					ret.add(agentno);
				}
			}
		}

		return ret;
	}


	public String toString(){

		if( conditions.isEmpty() ){
			return "nothing";
		}

		StringBuilder str = new StringBuilder();
		str.append("(");
		for( AbstractCondition condition : conditions ){
			if( str.length() > 1 ){
				str.append( " or " );
			}
			str.append( condition.toString() );
		}
		str.append(")");

		return str.toString();

	}

}
