package jp.halfmoon.inaba.aiwolf.guess;

import java.util.ArrayList;

import jp.halfmoon.inaba.aiwolf.condition.OrCondition;
import jp.halfmoon.inaba.aiwolf.condition.RoleCondition;

import org.aiwolf.common.data.Role;

/**
 * uہvNX
 * XRẢƏՂ̏󋵍肪ړI
 */
public final class FirstImpression extends AbstractGuessStrategy {

	// Xg
	private ArrayList<Guess> guesses = null;

	@Override
	public ArrayList<Guess> getGuessList(GuessStrategyArgs args) {

		// 擾ɍsNGXg̐ݒs
		if( guesses == null ){
			guesses = new ArrayList<Guess>();
			for( int i = 1; i <= args.agi.gameSetting.getPlayerNum(); i++ ){
				Guess guess;

				// eG[WFgTorl̃p^[A_0.95`1.05{Ɛ
				RoleCondition wolfCondition = RoleCondition.getRoleCondition( i, Role.WEREWOLF );
				RoleCondition posCondition = RoleCondition.getRoleCondition( i, Role.POSSESSED );

				guess = new Guess();
				guess.condition = new OrCondition().addCondition(wolfCondition).addCondition(posCondition);
				guess.correlation = 0.95 + Math.random() * 0.1;
				guesses.add(guess);

			}
		}

		// XgԂ
		return guesses;
	}

}
