package jp.halfmoon.inaba.aiwolf.guess;

import java.util.ArrayList;
import java.util.List;

import jp.halfmoon.inaba.aiwolf.strategyplayer.ReceivedGuess;

public final class GuessManager {



	/** SĂ̐ */
	private List<ReceivedGuess> allGuess = new ArrayList<ReceivedGuess>();

	/** eG[WFgP̂ɑ΂鐄 */
	private List<List<ReceivedGuess>> guessForSingleAgent = new ArrayList<List<ReceivedGuess>>();

	/** G[WFg̑gݍ킹ɑ΂鐄 */
	private List<ReceivedGuess> guessForMultiAgent = new ArrayList<ReceivedGuess>();


	/**
	 * RXgN^
	 * @param agentNum G[WFg
	 */
	public GuessManager(int agentNum){

		for( int i = 0; i <= agentNum; i++ ){
			guessForSingleAgent.add(new ArrayList<ReceivedGuess>());
		}

	}

	/**
	 * ǉ
	 * @param guess ǉ鐄
	 */
	public void addGuess(ReceivedGuess guess){

		// SĂ̐ƂĒǉ
		allGuess.add(guess);

		// p^[Ώۂ̃G[WFgԍꗗ擾
		ArrayList<Integer> TargetAgents = guess.guess.condition.getTargetAgentNo();

		// OEۂ̃G[WFgvPȉ
		if( TargetAgents.size()  <= 1 ){
			// PƃG[WFgɑ΂鐄ƂĒǉ
			int agentno = TargetAgents.get(0);
			guessForSingleAgent.get(agentno).add(guess);
		}else{
			// G[WFg̑gݍ킹ɑ΂鐄ƂĒǉ
			guessForMultiAgent.add(guess);
		}

	}

	/**
	 * ǉ
	 * @param guesses ǉ鐄̃Xg
	 */
	public void addGuess(List<ReceivedGuess> guesses){

		// P̒ǉ\bhgAPǉ
		for(ReceivedGuess guess: guesses){
			addGuess(guess);
		}

	}


	/**
	 * G[WFgP̂ɑ΂鐄擾
	 * @param agentno G[WFgԍ
	 * @return
	 */
	public List<ReceivedGuess> getGuessForSingleAgent(int agentno){
		return guessForSingleAgent.get(agentno);
	}


	/**
	 * G[WFgɑ΂鐄擾
	 * @return
	 */
	public List<ReceivedGuess> getGuessForMultiAgent(){
		return guessForMultiAgent;
	}



}
