package jp.halfmoon.inaba.aiwolf.lib;

import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Talk;

/**
 * J~OAEg(E̕\)\NX
 */
public final class ComingOut {

	/** G[WFgԍ */
	public final int agentNo;

	/** COE */
	public final Role role;

	/** CO */
	public final Talk commingOutTalk;

	/** COP񂵂 */
	public Talk cancelTalk;


	/**
	 * G[WFg̎擾
	 * @return
	 */
	public Agent getAgent(){
		return Agent.getAgent(agentNo);
	}

	/**
	 * RXgN^
	 * @param agentNo G[WFgԍ
	 * @param role COE
	 * @param commingOutTalkCO
	 */
	public ComingOut(int agentNo, Role role, Talk commingOutTalk){
		this.agentNo = agentNo;
		this.role = role;
		this.commingOutTalk = commingOutTalk;
	}


	/**
	 * COLȏԂ
	 * @return
	 */
	public boolean isEnable(){
		// COACOPOɗL
		if( commingOutTalk != null && cancelTalk == null ){
			return true;
		}

		return false;
	}


	/**
	 * COLȏԂ(w肵̒OԂƂĔ)
	 * @param day 
	 * @param talkID ID
	 * @return
	 */
	public boolean isEnable( int day, int talkID ){

		// COォ
		if( commingOutTalk != null || Common.compareTalkID( commingOutTalk.getDay(), commingOutTalk.getIdx(), day, talkID) == -1 ){
			// PO
			if( cancelTalk == null || Common.compareTalkID( commingOutTalk.getDay(), commingOutTalk.getIdx(), day, talkID) >= 0  ){
				// COACOPOɗL
				return true;
			}
		}

		return false;
	}

}
