package jp.halfmoon.inaba.aiwolf.lib;

import java.util.ArrayList;


/**
 * Twc\NX
 */
public final class WolfsidePattern{

	/** lT̃G[WFgԍ(Őݒ肷邱) */
	public final ArrayList<Integer> wolfAgentNo;

	/** l̃G[WFgԍ(Őݒ肷邱) */
	public final ArrayList<Integer> possessedAgentNo;

	/** Twc̖ */
	public String wolfSideName;


	/**
	 * RXgN^
	 * @param wolfAgentNo lT̃G[WFgԍ(Őݒ肷邱)
	 * @param possessedAgentNo l̃G[WFgԍ(Őݒ肷邱)
	 */
	public WolfsidePattern(ArrayList<Integer> wolfAgentNo, ArrayList<Integer> possessedAgentNo){
		this.wolfAgentNo = wolfAgentNo;
		this.possessedAgentNo = possessedAgentNo;

		// Twĉ̖̐ݒ
		setWolfSideName();
	}


	/**
	 * ̃G[WFgT
	 * @param agentno
	 * @return
	 */
	public boolean isWolf(int agentno){

		// ꂩ̘Tԍƈv邩
		return wolfAgentNo.contains(agentno);

	}


	/**
	 * ̃G[WFgl
	 * @param agentno
	 * @return
	 */
	public boolean isPossessed(int agentno){

		// ꂩ̋lԍƈv邩
		return possessedAgentNo.contains(agentno);

	}


	/**
	 * ̃G[WFgTwc
	 * @param agentno
	 * @return
	 */
	public boolean isWolfSide(int agentno){

		// ꂩ̘Tԍƈv邩A܂͂ꂩ̋lԍƈv邩
		return ( wolfAgentNo.contains(agentno) || possessedAgentNo.contains(agentno) );

	}

	/**
	 * Twĉ̖̐ݒ
	 */
	private void setWolfSideName(){

		StringBuilder sb = new StringBuilder();

		// Tꗗ\@jT[1,2,3]
		sb.append("T[");
		for( int wolf : wolfAgentNo ){
			sb.append(wolf).append(",");
		}
		if( !wolfAgentNo.isEmpty() ){
			sb.deleteCharAt(sb.length()-1);
		}
		sb.append("]");

		// lꗗ\@jl[1,2,3]
		sb.append(" l[");
		for( int pos : possessedAgentNo ){
			sb.append(pos).append(",");
		}
		if( !possessedAgentNo.isEmpty() ){
			sb.deleteCharAt(sb.length()-1);
		}
		sb.append("]");

		wolfSideName = sb.toString();

	}

	/**
	 * 
	 * @return 񉻂Twc
	 */
	public String toString(){
		return wolfSideName;
	}

}
