package jp.halfmoon.inaba.aiwolf.request;

import java.util.ArrayList;
import java.util.List;

import jp.halfmoon.inaba.aiwolf.lib.CauseOfDeath;
import jp.halfmoon.inaba.aiwolf.lib.Common;
import jp.halfmoon.inaba.aiwolf.lib.Judge;
import jp.halfmoon.inaba.aiwolf.lib.ViewpointInfo;
import jp.halfmoon.inaba.aiwolf.lib.VoteAnalyzer;

import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.net.GameInfo;


/**
 * spu{Ppv
 */
public final class BasicAttack extends AbstractActionStrategy {

	@Override
	public ArrayList<Request> getRequests(ActionStrategyArgs args) {

		GameInfo gameInfo = args.agi.latestGameInfo;

		ArrayList<Request> Requests = new ArrayList<Request>();
		Request workReq;


		// 錾ςݓ[͂̕擾
		VoteAnalyzer voteAnalyzer = VoteAnalyzer.loadSaidVote(args.agi);

		// Ă[ɉďP𔖂
		for( Agent agent : gameInfo.getAliveAgentList() ){
			workReq = new Request(agent);
			workReq.attack = Math.max( 1.00 - voteAnalyzer.getReceiveVoteCount(agent) * 0.08, 0.0 );
			Requests.add(workReq);
		}

		// ő[𓾂ĂG[WFg͏P悩珜O
		for( Agent agent : voteAnalyzer.getMaxReceiveVoteAgent() ){
			workReq = new Request(agent);
			workReq.attack = 0.05;
			Requests.add(workReq);
		}

		// eECO҂擾
		List<Integer> seers = args.agi.getEnableCOAgentNo(Role.SEER);
		List<Integer> mediums = args.agi.getEnableCOAgentNo(Role.MEDIUM);
		List<Integer> bodyguards = args.agi.getEnableCOAgentNo(Role.BODYGUARD);
		List<Integer> villagers = args.agi.getEnableCOAgentNo(Role.VILLAGER);


		//TODO 100ms᎞ԑȂ̂ŖłB߂H
//		// eG[WFg񂾏ꍇV~[g
//		if( args.agi.latestGameInfo.getDay() > 0 ){
//
//			for( int i = 1; i < args.agi.gameSetting.getPlayerNum(); i++ ){
//
//				// SρET͌XΏۂȂ̂ŃXLbv
//				if( args.agi.agentState[i].causeofDeath != CauseOfDeath.ALIVE ||
//				    args.agi.latestGameInfo.getRoleMap().get(Agent.getAgent(i)) == Role.WEREWOLF ){
//					continue;
//				}
//
//				// 񂾏ꍇ̎_肷
//				ViewpointInfo future;
//				future = new ViewpointInfo(args.agi.selfViewInfo);
//				future.removeWolfPattern(i);
//				if( future.wolfsidePatterns.isEmpty() ){
//					// j]̂ŏPȂ
//					workReq = new Request(i);
//					workReq.attack = 0.05;
//					Requests.add(workReq);
//				}
//
//
//				// 񂾏ꍇ̑l_肷
//				// i񂾎_쐬iS_j
//				future = new ViewpointInfo(args.agi.allViewTrustInfo);
//				future.removeWolfPattern(i);
//
//				// n̘T␔(̐Ґ - ݐ܂ފm̐)
//				int grayAndBlackNum = 0;
//				for( int j = 1; j < voteReceiveNum.length; j++ ){
//					// ݐłȂ    ̊m蔒ł͂Ȃ
//					if( j != i && args.agi.agentState[j].causeofDeath == CauseOfDeath.ALIVE && !future.isFixWhite(j) ){
//						grayAndBlackNum++;
//					}
//				}
//
//				// ̎c菈Y擾
//				int tomorrowRestExucuteNum = Common.getRestExecuteCount(args.agi.latestGameInfo.getAliveAgentList().size() - 2);
//
//				//TODO ݂悪O[Ƃl(͔JEgŌvZ)
//				//TODO ľvZ(͐ŌvZ)
//				//TODO 肢t𐶂ꍇ͊D܂邱Ƃl
//
//				// l݂in̘T̐c݂萔ȉj
//				if( grayAndBlackNum <= tomorrowRestExucuteNum - 1 ){
//					// lނ̂ŏPȂ
//					workReq = new Request(i);
//					workReq.attack = 0.05;
//					Requests.add(workReq);
//				}
//
//			}
//
//		}


		// lĂPȂ
		for( Judge judge : args.agi.getSeerJudgeList() ){
			// lԂ̐肢tԈo
			if( !args.agi.isWolf(judge.agentNo) &&
			    (judge.result == Species.WEREWOLF) != args.agi.isWolf(judge.targetAgentNo) ){
				// Pv
				workReq = new Request(judge.agentNo);
				workReq.attack = 0.5;
				Requests.add(workReq);
			}
		}


		// 肢tЂłȂΏPȂ
		for( Judge judge : args.agi.getSeerJudgeList() ){
			// 肢
			if( judge.agentNo == judge.targetAgentNo ){
				// Pv
				workReq = new Request(judge.agentNo);
				workReq.attack = 0.5;
				Requests.add(workReq);
			}
		}


		// P
		if( args.agi.latestGameInfo.getDay() == 1 ){

			//TODO CO҂݂ꂻȂ}~͂͋CɂȂĂ

			// 0COȂ͏PȂ(D̐_)
			if( seers.isEmpty() ){
				for( int medium : mediums ){
					workReq = new Request( medium );
					workReq.attack = 0.1;
					Requests.add(workReq);
				}
			}

			// 1COȂ͏PȂ(q\z邽)
			if( seers.size() == 1 ){
				workReq = new Request( seers.get(0) );
				workReq.attack = 0.1;
				Requests.add(workReq);
			}

		}


		//TODO CO҂݂ꂻȂ}~͂͋CɂȂĂ

		// GJoĂꍇ
		if( args.agi.latestGameInfo.getDay() >= 2 && args.agi.latestGameInfo.getAttackedAgent() == null ){
			// P̌𓾂
			List<Integer> maxVoteAgentList = Common.getMaxVoteAgentNo( args.agi.latestGameInfo.getAttackVoteList() );

			// ݂ƒ݂̔̉\Ȃ
			if( maxVoteAgentList.indexOf( args.agi.latestGameInfo.getExecutedAgent().getAgentIdx() ) == -1 ){
				// GJʒu͑ďPȂ
				for( Integer agent : maxVoteAgentList ){
					workReq = new Request( agent );
					workReq.attack = 0.2;
					Requests.add(workReq);
				}
				// PȂ
				for( int medium : mediums ){
					workReq = new Request( medium );
					workReq.attack = 0.2;
					Requests.add(workReq);
				}
//				// ̏Pv
//				for( int seer : seers ){
//					workReq = new Request( seer );
//					workReq.attack = 0.1;
//					Requests.add(workReq);
//				}
//				for( int medium : mediums ){
//					workReq = new Request( medium );
//					workReq.attack = 0.1;
//					Requests.add(workReq);
//				}
			}
		}


		return Requests;
	}

}
