package jp.halfmoon.inaba.aiwolf.request;

import java.util.List;

import org.aiwolf.common.data.Agent;

/**
 * sNGXg\NX
 */
public final class Request {

	/* esv̋xA1Ƃ{Ŏw肷B */

	public int agentNo;			// G[WFgԍ

	public double vote = 1;		// [(YƓ`)
	public double attack = 1;	// P
	public double guard = 1;	// q
	public double inspect = 1;	// 肢


	/**
	 * RXgN^
	 * @param agent G[WFg
	 */
	public Request(Agent agent){
		this.agentNo = agent.getAgentIdx();
	}


	/**
	 * RXgN^
	 * @param agentNo G[WFgԍ
	 */
	public Request(int agentNo){
		this.agentNo = agentNo;
	}


	/**
	 * ̍sv̂A[vő̂̂擾
	 * @param requests
	 * @return
	 */
	public static Request getMaxVoteRequest(List<Request> requests){

		Request result = null;
		double maxValue = Double.NEGATIVE_INFINITY;

		for( Request req : requests ){
			if( req.vote > maxValue ){
				result = req;
				maxValue = req.vote;
			}
		}

		return result;

	}


	/**
	 * ̍sv̂A肢vő̂̂擾
	 * @param requests
	 * @return
	 */
	public static Request getMaxInspectRequest(List<Request> requests){

		Request result = null;
		double maxValue = Double.NEGATIVE_INFINITY;

		for( Request req : requests ){
			if( req.inspect > maxValue ){
				result = req;
				maxValue = req.inspect;
			}
		}

		return result;

	}


	/**
	 * ̍sv̂Aqvő̂̂擾
	 * @param requests
	 * @return
	 */
	public static Request getMaxGuardRequest(List<Request> requests){

		Request result = null;
		double maxValue = Double.NEGATIVE_INFINITY;

		for( Request req : requests ){
			if( req.guard > maxValue ){
				result = req;
				maxValue = req.guard;
			}
		}

		return result;

	}


	/**
	 * ̍sv̂APvő̂̂擾
	 * @param requests
	 * @return
	 */
	public static Request getMaxAttackRequest(List<Request> requests){

		Request result = null;
		double maxValue = Double.NEGATIVE_INFINITY;

		for( Request req : requests ){
			if( req.attack > maxValue ){
				result = req;
				maxValue = req.attack;
			}
		}

		return result;

	}




}
