package jp.halfmoon.inaba.aiwolf.request;

import java.util.ArrayList;

import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.net.GameInfo;

import jp.halfmoon.inaba.aiwolf.lib.VoteAnalyzer;


/**
 * spu[dˁv
 * {z肷铮́Aʂ\݂Ă邱ƁB
 */
public final class VoteStack extends AbstractActionStrategy {

	@Override
	public ArrayList<Request> getRequests(ActionStrategyArgs args) {

		GameInfo gameInfo = args.agi.latestGameInfo;

		ArrayList<Request> Requests = new ArrayList<Request>();
		Request workReq;



		// 錾ςݓ[͂̕擾
		VoteAnalyzer voteAnalyzer = VoteAnalyzer.loadSaidVote(args.agi);

		// Ă[ɉĕ[d˂
		for( Agent agent : gameInfo.getAliveAgentList() ){
			workReq = new Request(agent);
			workReq.vote = 1.00 + voteAnalyzer.getReceiveVoteCount(agent) * 0.02 * (1 + voteAnalyzer.getReceiveVoteCount(gameInfo.getAgent()) * 0.05);
			Requests.add(workReq);
		}


		// l̏
		if( args.agi.latestGameInfo.getRole() == Role.POSSESSED ){
			for( Agent agent : gameInfo.getAliveAgentList() ){
				// _Ŋm
				if( args.agi.selfRealRoleViewInfo.isFixBlack(agent.getAgentIdx()) ){
					Agent target = voteAnalyzer.getVoteTarget(agent);
					// [錾Ă邩
					if( target != null ){
						// TlƓꏊɓ[
						workReq = new Request(target);
						workReq.vote = 1.2;
						Requests.add(workReq);
					}
				}
			}
		}


		return Requests;

	}

}
