package jp.halfmoon.inaba.aiwolf.strategyplayer;

import java.util.List;

import jp.halfmoon.inaba.aiwolf.lib.CauseOfDeath;
import jp.halfmoon.inaba.aiwolf.lib.DayInfo;

import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;


public class StrategyBodyGuard extends AbstractBaseStrategyPlayer {


	@Override
	public String talk() {

		try{

			String workString;

			// CȌꍇ
			if( !isCameOut ){

				//TODO s͗vikajiAgent͎CO݂肽̂ŁAhł͈ɂȂj
				// COKvȂCO
				if( isAvoidance() ){
					isCameOut = true;

					// b
					workString = TemplateTalkFactory.comingout(getMe(), Role.BODYGUARD);
					return workString;
				}

				// COKvȂCO
				if( isVoluntaryComingOut() ){
					isCameOut = true;

					// b
					workString = TemplateTalkFactory.comingout(getMe(), Role.BODYGUARD);
					return workString;
				}

			}

			// COς̏ꍇ
			if( isCameOut ){

				// 񍐂̌ʂ񍐂
				if( agi.reportSelfResultCount < agi.selfGuardRecent.size() ){

					int reportDay = agi.reportSelfResultCount + 1;
					Agent agent = Agent.getAgent( agi.selfGuardRecent.get(reportDay) );

					// 񍐍ς݂̌𑝂₷
					agi.reportSelfResultCount++;

					// b
					workString = TemplateTalkFactory.guarded( agent );
					return workString;
				}

			}

			// [ĂȂꍇAV[b
			if( declaredPlanningVoteAgent == null ){
				// [ύX
				actionUI.voteAgent = planningVoteAgent;
				declaredPlanningVoteAgent = planningVoteAgent;

				// ŏI͘T̕֏[hߐ錾ȂB錾͍ŏIȊOƂ
				if( agi.latestGameInfo.getAliveAgentList().size() > 4 ){
					// b
					String ret = TemplateTalkFactory.vote( Agent.getAgent(planningVoteAgent) );
					return ret;
				}
			}

			// ^T̐lȏ㌾ĂȂΘb
			if( agi.talkedSuspicionAgentList.size() < agi.gameSetting.getRoleNumMap().get(Role.WEREWOLF) ){
				// ^b͂擾A擾łĂΘb
				workString = getSuspicionTalkString();
				if( workString != null ){
					return workString;
				}
			}

			// [ύXꍇAV[b
			if( declaredPlanningVoteAgent != planningVoteAgent ){
				// [ύX
				actionUI.voteAgent = planningVoteAgent;
				declaredPlanningVoteAgent = planningVoteAgent;

				// ŏI͘T̕֏[hߐ錾ȂB錾͍ŏIȊOƂ
				if( agi.latestGameInfo.getAliveAgentList().size() > 4 ){
					// b
					String ret = TemplateTalkFactory.vote( Agent.getAgent(planningVoteAgent) );
					return ret;
				}
			}

			// ^b͂擾A擾łĂΘb
			workString = getSuspicionTalkString();
			if( workString != null ){
				return workString;
			}

			// Mpb͂擾A擾łĂΘb
			workString = getTrustTalkString();
			if( workString != null ){
				return workString;
			}

			// bꍇAoverԂ
			return TemplateTalkFactory.over();

		}catch(Exception ex){

			// G[overԂ
			return TemplateTalkFactory.over();

		}

	}


	/**
	 * ICO邩
	 * @return
	 */
	private boolean isVoluntaryComingOut(){

		// eECO҂擾
		List<Integer> seers = agi.getEnableCOAgentNo(Role.SEER);
		List<Integer> mediums = agi.getEnableCOAgentNo(Role.MEDIUM);
		List<Integer> bodyguards = agi.getEnableCOAgentNo(Role.BODYGUARD);

		// x肪݁ASĂ̐lOSIoĂ
		if( bodyguards.size() > 0 &&
		    seers.size() + mediums.size() + bodyguards.size() >= 6 ){
			// CO
			return true;
		}

		// x肪()A҂Ulȉ
		if( bodyguards.size() > 0 &&
		    agi.latestGameInfo.getAliveAgentList().size() <= 6 ){
			for( int bodyguard : bodyguards ){
				if( agi.agentState[bodyguard].causeofDeath == CauseOfDeath.ALIVE ){
					return true;
				}
			}
		}

		// GJ񐔂JEg
		int gjCount = 0;
		for( DayInfo dayInfo : agi.dayInfoList ){
			if( dayInfo.day >= 2 && dayInfo.attackAgentNo == null ){
				gjCount++;
			}
		}

		//TODO ҐΉEmȂǂlׂH
		// GJ񐔂QȏォiG16ł͕aQłPꑝj
		if( gjCount >= 2 ){
			// 1COłȂCO
			if( seers.size() > 1 ){
				return true;
			}
		}

		return false;

	}

}
