package jp.halfmoon.inaba.aiwolf.strategyplayer;

import java.util.List;

import jp.halfmoon.inaba.aiwolf.lib.Common;
import jp.halfmoon.inaba.aiwolf.lib.Judge;
import jp.halfmoon.inaba.aiwolf.lib.ViewpointInfo;

import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.client.lib.TemplateWhisperFactory;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.net.GameInfo;


public class StrategyWerewolf extends AbstractBaseStrategyPlayer {


	@Override
	public void dayStart() {

		super.dayStart();

		// x蔻̒ǉ
		if( agi.fakeRole == Role.SEER ){
			if( agi.latestGameInfo.getDay() > 0 ){
				addFakeSeerJudge();
			}
		}

	}

	@Override
	public String talk() {

		try{

			// j]̔
			if( agi.selfViewInfo.wolfsidePatterns.isEmpty() ){

				// Ƃ肠CO
				if( !isCameOut ){
					isCameOut = true;

					String ret = TemplateTalkFactory.comingout( getMe(), Role.MEDIUM );
					return ret;
				}

				return TemplateTalkFactory.over();

			}


			// xÊbn
			if( agi.fakeRole == Role.SEER ){
				if( !isCameOut ){
					isCameOut = true;

					String ret = TemplateTalkFactory.comingout( getMe(), agi.fakeRole );
					return ret;
				}
			}


			// COς̏ꍇ
			if( isCameOut ){

				// CO
				if( agi.fakeRole == Role.SEER ){

					// 񍐂̌ʂ񍐂
					if( agi.reportSelfResultCount < agi.selfInspectList.size() ){

						Judge reportJudge = agi.selfInspectList.get( agi.selfInspectList.size() - 1 );

						// 񍐍ς݂̌𑝂₷
						agi.reportSelfResultCount++;

						// b
						String ret = TemplateTalkFactory.divined( Agent.getAgent(reportJudge.targetAgentNo), reportJudge.result );
						return ret;
					}

				}

			}

			// ^T̐lȏ㌾ĂȂΘb
	//		if( agi.talkedSuspicionAgentList.size() < agi.gameSetting.getRoleNumMap().get(Role.WEREWOLF) ){
	//			// ^b͂擾A擾łĂΘb
	//			workString = getSuspicionTalkString();
	//			if( workString != null ){
	//				return workString;
	//			}
	//		}

			// [ύXꍇAV[b
			if( declaredPlanningVoteAgent != planningVoteAgent ){
				// [ύX
				actionUI.voteAgent = planningVoteAgent;
				declaredPlanningVoteAgent = planningVoteAgent;

				// b
				String ret = TemplateTalkFactory.vote( Agent.getAgent(planningVoteAgent) );
				return ret;
			}

			// bꍇAoverԂ
			return TemplateTalkFactory.over();

		}catch(Exception ex){

			// G[overԂ
			return TemplateTalkFactory.over();

		}

	}



	@Override
	public String whisper(){

		// xE̕
		if( declaredFakeRole != agi.fakeRole ){
			declaredFakeRole = agi.fakeRole;
			return TemplateWhisperFactory.comingout(getMe(), agi.fakeRole);
		}

		// ݐ̕
		if( declaredPlanningAttackAgent != actionUI.attackAgent && actionUI.attackAgent != null ){
			declaredPlanningAttackAgent = actionUI.attackAgent;
			return TemplateWhisperFactory.attack( Agent.getAgent(actionUI.attackAgent) );
		}

		return TemplateWhisperFactory.over();
	}


	@Override
	public Agent attack() {

		if( actionUI.attackAgent == null ){
			return null;
		}

//TODO nullɂĂɏPۂHv
//		// ҂TliYSljŋ
//		if( agi.latestGameInfo.getAliveAgentList().size() == 5 ){
//			return null;
//		}

		return Agent.getAgent(actionUI.attackAgent);

	}


	@Override
	public Agent vote() {

		// 錾ŉ߂ΏĂԂ
		Integer ppVoteAgentNo = getSuspectedPPVoteAgent();
		if( ppVoteAgentNo != null ){
			return Agent.getAgent(ppVoteAgentNo);
		}

		if( actionUI.voteAgent == null ){
			// [錾oĂȂꍇA[悤ƎvĂ҂ɓ[
			if( planningVoteAgent == null ){
				return null;
			}
			return Agent.getAgent(planningVoteAgent);
		}
		return Agent.getAgent(actionUI.voteAgent);

	}


	/**
	 * 錾ŏĂꍇA[擾
	 * @return
	 */
	public Integer getSuspectedPPVoteAgent(){

		List<Integer> aliveWolfList = agi.getAliveWolfList();

		// ƂPl݂ΏĂԂ
		if( aliveWolfList.size() >= Common.getRestExecuteCount(agi.latestGameInfo.getAliveAgentList().size()) ){

			GameInfo gameInfo = agi.latestGameInfo;

			// is
			if( agi.latestGameInfo.getAliveAgentList().size() % 2 == 1 ){

				// G[WFg̓[\擾
				Integer[] voteTarget = new Integer[agi.gameSetting.getPlayerNum() + 1];
				for( Agent agent : gameInfo.getAliveAgentList() ){
					voteTarget[agent.getAgentIdx()] = agi.getSaidVoteAgent(agent.getAgentIdx());
					if( voteTarget[agent.getAgentIdx()] == null ){
						// 錾҂ꍇ͕smvf̂ł߂Ă
						return null;
					}
				}

				// G[WFg̔퓊[擾
				int[] voteReceiveNum = new int[agi.gameSetting.getPlayerNum() + 1];
				int[] voteReceiveNumWithoutMe = new int[agi.gameSetting.getPlayerNum() + 1];
				for( int i = 1; i < voteTarget.length; i++ ){
					// [錾JEg
					if( voteTarget[i] != null ){
						voteReceiveNum[voteTarget[i]]++;
					}
					// ȊO̓[錾JEg
					if( i != gameInfo.getAgent().getAgentIdx() && voteTarget[i] != null ){
						voteReceiveNumWithoutMe[voteTarget[i]]++;
					}
				}

				// ő[̃G[WFg̕[擾
				int maxVoteCount = 0;
				for( int i = 1; i < voteTarget.length; i++ ){
					if( voteReceiveNumWithoutMe[i] > maxVoteCount ){
						maxVoteCount = voteReceiveNum[i];
					}
				}

				// ő[𓾂ĂG[WFg擾
				for( int i = 1; i < voteReceiveNum.length; i++ ){
					if( voteReceiveNumWithoutMe[i] >= maxVoteCount ){
						// ̓[ƘT݂ꂻH
						if( aliveWolfList.contains(i) ){
							// ɍő[̐lԂȂ牟߂Ώ
							for( int j = 1; j < voteReceiveNum.length; j++ ){
								if( voteReceiveNumWithoutMe[j] >= maxVoteCount && !aliveWolfList.contains(j) ){
									return j;
								}
							}
							// LWɍő[Ȃ
							if( aliveWolfList.size() <= 1 ){
								for( int j = 1; j < voteReceiveNum.length; j++ ){
									// 1[̐lԂΉŃ_
									if( voteReceiveNumWithoutMe[j] >= maxVoteCount - 1 && !aliveWolfList.contains(j) ){
										return j;
									}
								}
							}
						}
					}
				}

			}

		}

		return null;

	}


	/**
	 * 肢ǉ
	 */
	private void addFakeSeerJudge(){

		GameInfo gameInfo = agi.latestGameInfo;

		// E茋ʂ̉ݒ
		int inspectAgentNo = latestRequest.getMaxInspectRequest().agentNo;
		Species result = Species.HUMAN;

		// PꂽG[WFg̎擾
		Agent attackedAgent = agi.latestGameInfo.getAttackedAgent();

		// oꍇ̎_肷
		ViewpointInfo future = new ViewpointInfo(agi.selfViewInfo);
		future.removeWolfPattern(inspectAgentNo);

		// oœ󂪔j]ꍇAos
		if( future.wolfsidePatterns.isEmpty() ){
			result = Species.WEREWOLF;
		}

		// 肨Ƃ悪܂ꂽ
		if( attackedAgent != null && attackedAgent.getAgentIdx() == inspectAgentNo ){
			// ݐɂ͐lԔo
			result = Species.HUMAN;
		}

		List<Integer> aliveWolfList = agi.getAliveWolfList();


		// ƂPl݂ΏĂԂ
		if( aliveWolfList.size() >= Common.getRestExecuteCount(agi.latestGameInfo.getAliveAgentList().size()) ){
			for( Agent agent : agi.latestGameInfo.getAliveAgentList() ){
				// Ԃ̘Tł͂Ȃ@@_mł͂Ȃ@ł͂Ȃ@l
				if( agi.latestGameInfo.getRoleMap().get(agent) == null &&
				    !agi.selfViewInfo.isFixWhite(agent.getAgentIdx()) &&
				    agi.agentState[agent.getAgentIdx()].comingOutRole != Role.MEDIUM ){

					// oꍇ̎_肷
					future = new ViewpointInfo(agi.selfViewInfo);
					future.removePatternFromJudge( getMe().getAgentIdx(), agent.getAgentIdx(), Species.WEREWOLF );

					// oĔj]ȂȂ炻ɍo
					if( !future.wolfsidePatterns.isEmpty() ){
						inspectAgentNo = agent.getAgentIdx();
						result = Species.WEREWOLF;
						break;
					}
				}
			}
		}



		Judge newJudge = new Judge( getMe().getAgentIdx(),
		                            inspectAgentNo,
		                            result,
		                            null );

		agi.addFakeSeerJudge(newJudge);

	}


}
